Entities = {}
Entities.objects = {}
Entities.objpath = "entities/"
local register = {}
local id = 0

function Entities.initialize()
    register["Star"] = love.filesystem.load(Entities.objpath .. "Star.lua")
    register["Freeze"] = love.filesystem.load(Entities.objpath .. "Freeze.lua")
    register["Enemy"] = love.filesystem.load(Entities.objpath .. "Enemy.lua")    
    register["FuelCan"] = love.filesystem.load(Entities.objpath .. "FuelCan.lua")    
	register["Player"] = love.filesystem.load(Entities.objpath .. "Player.lua")       
	register["Cloud"] = love.filesystem.load(Entities.objpath .. "Cloud.lua")   
	register["Smoke"] = love.filesystem.load(Entities.objpath .. "Smoke.lua")        
end

function Entities.derive(name)
	return love.filesystem.load(Entities.objpath .. name .. ".lua")()
end

function Entities.create(name, x, y, r, s)
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end

	if not w then
		w = 0
	end

	if not h then
		h = 0
	end
	
	if register[name] then
		id = id + 1
		local Entity = register[name]()
		Entity:load(r, s)
		Entity:setBody(x, y)
		Entity:setPos(x, y)
		Entity.id = id
		Entities.objects[#Entities.objects + 1] = Entity
		return Entities.objects[#Entities.objects]
	else
		print("Error: Entity " .. name .. " does not exist.")
		return false;
	end
end

function Entities.destroy(id)
	if Entities.objects[id] then
		if Entities.objects[id].die then
			Entities.objects[id]:die()
		end
		Entities.objects[id] = nil
	end
end

function Entities.destroyAll()
	Entities.objects = nil
	Entities.objects = {}
end

function Entities:draw()
	for i, Entity in pairs(Entities.objects) do
		if Entity.draw then
			Entity:draw()
		end
	end
end

function Entities:keypressed(key)
	for i, Entity in pairs(Entities.objects) do
		if Entity.keypressed then
			Entity:keypressed(key)
		end
	end
end

function Entities:keyreleased(key)
	for i, Entity in pairs(Entities.objects) do
		if Entity.keyreleased then
			Entity:keyreleased(key)
		end
	end
end

function Entities:mousepressed(x, y, button)
	for i, Entity in pairs(Entities.objects) do
		if Entity.mousepressed then
			Entity:mousepressed(x, y, button)
		end
	end
end

function Entities:mousereleased(x, y, button)
	for i, Entity in pairs(Entities.objects) do
		if Entity.mousereleased then
			Entity:mousereleased(x, y, button)
		end
	end
end

function Entities:update(dt)
	for i, Entity in pairs(Entities.objects) do
		if Entity.update then
			Entity:update(love.timer.getDelta())
		end
	end
end
