love.graphics.setMode(700, 450)

game = "Plane"
version = "beta 0.3"
gamestate = "logo"

require('libs.middleclass')
Timer = require('libs.timer')
require('libs.storage')
require('entities')
HUD = require('hud')
HUD = Hud:new()
menu = require('menu')
menu = Menu:new()
HC = require('libs/hc')
levels = require('level')
levels = Level:new()

logo_alpha = 0
logo_start = false
local tmp = false

font14 = love.graphics.newFont("font.ttf", 14)
font22 = love.graphics.newFont("font.ttf", 22)
font44 = love.graphics.newFont("font.ttf", 44)

-- Save file
if not love.filesystem.exists("save.lua") then
	local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 = 0\nhighscore2 = 0\nhighscore3 = 0\nhighscore4 = 0\nplane = 1\nengine = 1\nfuel_tank = 1\nshield = 1\nstars = 0\nend\n\nreturn Save\n"
	storage.save("save.lua", save)
end
save = love.filesystem.load("save.lua")
local Save = save()
Save:load()

logo = love.graphics.newImage("sprites/logo.png")
background = love.graphics.newImage("sprites/background.png")
menu = love.graphics.newImage("sprites/menu.png")
button = love.graphics.newImage("sprites/button.png")
plane1 = love.graphics.newImage("sprites/plane_1.png")
plane2 = love.graphics.newImage("sprites/plane_2.png")
plane3 = love.graphics.newImage("sprites/plane_3.png")
lobby = love.graphics.newImage("sprites/lobby.png")
crash = love.graphics.newImage("sprites/crash.png")
pause = love.graphics.newImage("sprites/pause.png")
star = love.graphics.newImage("sprites/star.png")
superstar = love.graphics.newImage("sprites/star.png")
cloud1 = love.graphics.newImage("sprites/cloud_1.png")
cloud2 = love.graphics.newImage("sprites/cloud_2.png")
smoke = love.graphics.newImage("sprites/smoke.png")
fuelcan = love.graphics.newImage("sprites/fuel.png")
freeze = love.graphics.newImage("sprites/freeze.png")
freezebg = love.graphics.newImage("sprites/freeze_bg.png")
background2 = love.graphics.newImage("sprites/background_2.png")
fog = love.graphics.newImage("sprites/fog.png")
bar = love.graphics.newImage("sprites/bar.png")
fbar = love.graphics.newImage("sprites/fuel_bar.png")
sbar = love.graphics.newImage("sprites/shield_bar.png")
vignette = love.graphics.newImage("sprites/vignette.png")

function on_collision(dt, shape_a, shape_b)
    for i=1,#starent do
        if shape_a == starent[i].body and shape_b == player.body then
            shape_a:moveTo(-100, -100)
            player.earn = player.earn + 1
            player.score = player.score + 5 * player.combo
            player.combo = player.combo + 1
            comboResetTimer = 0
        end
        if shape_a == player.body and shape_b == starent[i].body then
            shape_b:moveTo(-100, -100)
            player.earn = player.earn + 1
            player.score = player.score + 5 * player.combo
            player.combo = player.combo + 1
            comboResetTimer = 0
        end
    end
    for i=1,#enemyent do
        if freezetime == false then
            if shape_a == enemyent[i].body and shape_b == player.body then
                if shield == 1 then
                    player.shields = player.shields - dt*20
                elseif shield == 2 then
                    player.shields = player.shields - dt*15
                elseif shield == 3 then
                    player.shields = player.shields - dt*10
                end
            end
            if shape_a == player.body and shape_b == enemyent[i].body then
                if shield == 1 then
                    player.shields = player.shields - dt*20
                elseif shield == 2 then
                    player.shields = player.shields - dt*15
                elseif shield == 3 then
                    player.shields = player.shields - dt*10
                end
            end
        end
    end
    for i=1,#freezeent do
        if shape_a == freezeent[i].body and shape_b == player.body then
            freezetime = true
            Timer.add(30, function() freezetime = false end)
        end
        if shape_a == player.body and shape_b == freezeent[i].body then
            freezetime = true
            Timer.add(30, function() freezetime = false end)
        end
    end
    for i=1,#fuelent do
        if shape_a == fuelent[i].body and shape_b == player.body then
            shape_a:moveTo(-100, -100)
            for i=1,50 do
                if player.fuel+1 < player.fuelMax then
                    player.fuel = player.fuel + 1
                end
            end
        end
        if shape_a == player.body and shape_b == fuelent[i].body then
            shape_b:moveTo(-100, -100)
            for i=1,50 do
                if player.fuel+1 < player.fuelMax then
                    player.fuel = player.fuel + 1
                end
            end
        end
    end
end

function love.load()
	Entities.initialize()
    Collider = HC(100, on_collision)    
end

function love.update(dt)
	if gamestate == "playing" then
        Collider:update(dt)
		Entities.update()
		Timer.update(dt)
		HUD:update(dt)
        levels:update(dt)
        if player.health == 0 then
            gamestate = "crash"
        end
    
    elseif gamestate == "menu" then
        Menu:update(dt)

	elseif gamestate == "logo" then
		if logo_alpha == 0 and logo_start == false then
			logo_start = true
		end

		if logo_start == true and logo_alpha < 200 and tmp == false then
			logo_alpha = logo_alpha + dt*90
		end

		if logo_alpha > 200 and tmp == false then
			tmp = true
		end

        if tmp == true then
            logo_alpha = logo_alpha - dt*90
        end

        if logo_alpha < 10 and tmp == true then
            gamestate = "menu"
        end

		Timer.update(dt)
	end
end

function love.draw()
	if gamestate == "playing" or gamestate == "crash" or gamestate == "pause" then
		love.graphics.setColor(255, 255, 255, 255)
        if level == 1 then
		    love.graphics.draw(background, 0, 0)
        else
            love.graphics.draw(background2, 0, 0)
        end
		Entities:draw()
		HUD:draw()
        if gamestate == "crash" then
		    love.graphics.draw(crash, 0, 0)
            love.graphics.setFont(font14)
            love.graphics.print("Score: "..player.score.."\nStars: +"..player.earn, 280, 130)
        end
        if gamestate == "pause" then
		    love.graphics.draw(pause, 0, 0)
            love.graphics.setFont(font14)  
            love.graphics.print("Score: "..player.score.."\nStars: +"..player.earn, 280, 130)
        end

	elseif gamestate == "menu" then
		Menu:draw()

	elseif gamestate == "logo" then
		love.graphics.setColor(255,255,255,logo_alpha) 
		love.graphics.draw(logo, 0, 0)
    end
end

function love.keypressed(key)
	if gamestate == "playing" then
		Entities:keypressed(key)

		if key == "escape" then
			gamestate = "pause"
		end

	elseif gamestate == "menu" then
		Menu:keypressed(key)

	elseif gamestate == "logo" and key == " " then
		gamestate = "menu"

    elseif gamestate == "crash" and key == "return" then
        stars = stars + player.earn
        if level == 1 then
            if player.score > highscore1 then
                highscore1 = player.score
            end
        end
        if level == 2 then
            if player.score > highscore2 then
                highscore2 = player.score
            end
        end
        if level == 3 then
            if player.score > highscore3 then
                highscore3 = player.score
            end
        end
        if level == 4 then
            if player.score > highscore4 then
                highscore4 = player.score
            end
        end
        local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 ="..highscore1.."\nhighscore2 ="..highscore2.."\nhighscore3 ="..highscore3.."\nhighscore4 ="..highscore4.."\nplane = "..plane.."\nengine = "..engine.."\nfuel_tank = "..fuel_tank.."\nshield = "..shield.."\nstars = "..stars.."\nend\n\nreturn Save\n"
        storage.save("save.lua", save)
        gamestate = "menu"
        Collider:clear()
        Entities.destroyAll()
        Timer.clear()

    elseif gamestate == "pause" and key == "return" then
        gamestate = "playing"
    
	end
end

function love.keyreleased(key)
	if gamestate == "playing" then
		Entities:keyreleased(key)
	end
end


