Menu = class('Menu')

local alpha = 0
local selected = 1
local state = 0
local mode = 1

function Menu:initialize()
end

function Menu:update(dt)
    if alpha < 250 then
        alpha = alpha + dt*45
    end
end

function Menu:draw(dt)
    if state == 0 then
        love.graphics.setColor(255,255,255,alpha)    
        love.graphics.draw(menu, 0, 0)
        love.graphics.setFont(font22)

        if selected == 1 then
            love.graphics.draw(button, 280, 130)
            love.graphics.setColor(0,0,0)                
        end
        love.graphics.print("Play", 280, 130)
        love.graphics.setColor(255,255,255,alpha)    
        
        if selected == 2 then
            love.graphics.draw(button, 280, 160)
            love.graphics.setColor(0,0,0)                            
        end
        love.graphics.print("Fullscreen", 280, 160)
        love.graphics.setColor(255,255,255,alpha)    

        if selected == 3 then
            love.graphics.draw(button, 280, 190)
            love.graphics.setColor(0,0,0)                            
        end
        love.graphics.print("Quit", 280, 190)
        love.graphics.setColor(255,255,255,alpha)    

        love.graphics.setFont(font14)       
        love.graphics.setColor(255,255,255,200)
        love.graphics.print(game.." "..version, 590, 425)

    else  -- //** LOBBY **// --
        love.graphics.setColor(255,255,255)
        love.graphics.draw(lobby, 0, 0)
        love.graphics.setFont(font14)
        if plane == 1 then
            love.graphics.draw(plane1, 60, 120, -0.10, 2)
        elseif plane == 2 then
            love.graphics.draw(plane2, 60, 120, -0.10, 2)
        elseif plane == 3 then
            love.graphics.draw(plane3, 60, 120, -0.10, 2)
        end
        love.graphics.setColor(0,0,0)
        love.graphics.print(stars, 580, 63)   
        love.graphics.setColor(255,255,255)        
        love.graphics.print("Plane: Level "..plane, 60, 260)    
        love.graphics.print("Engine: Level "..engine, 60, 280)
        love.graphics.print("Fuel tank: Level "..fuel_tank, 60, 300)
        love.graphics.print("Shield: Level "..shield, 60, 320)
        
        planecost = plane*1000
        enginecost = engine*200
        ftankcost = fuel_tank*250
        shieldcost = shield*500
       
        love.graphics.setColor(80,80,80,100)       
        if selected == 1 and mode == 2 then
            love.graphics.rectangle("fill", 500, 110, 140, 35)
        end
        if selected == 2 and mode == 2 then
            love.graphics.rectangle("fill", 500, 150, 140, 35)
        end
        if selected == 3 and mode == 2 then
            love.graphics.rectangle("fill", 500, 190, 140, 35)
        end
        if selected == 4 and mode == 2 then
            love.graphics.rectangle("fill", 500, 230, 140, 35)
        end
        love.graphics.setColor(255,255,255,255)

        if plane > 2 then
            love.graphics.setColor(100,100,100)
        end
        love.graphics.print("Upgrade plane\n"..planecost.." stars", 505, 110)

        love.graphics.setColor(255,255,255)     
        if engine > 2 then
            love.graphics.setColor(100,100,100)
        end
        love.graphics.print("Upgrade engine\n"..enginecost.." stars", 505, 150)

        love.graphics.setColor(255,255,255)
        if fuel_tank > 3 or plane < 2 then
            love.graphics.setColor(100,100,100)
        end
        love.graphics.print("Upgrade fuel tank\n"..ftankcost.." stars", 505, 190)

        love.graphics.setColor(255,255,255)        
        if shield > 2 or plane < 3 then
            love.graphics.setColor(100,100,100)
        end
        love.graphics.print("Upgrade shield\n"..shieldcost.." stars", 505, 230)
        love.graphics.setColor(255,255,255)     
        
        if selected == 1 and mode == 1 then
            love.graphics.setColor(80,80,80,100)        
            love.graphics.rectangle("fill", 340, 110, 140, 50)
        elseif selected == 2 and mode == 1 then
            love.graphics.setColor(80,80,80,100)
            love.graphics.rectangle("fill", 340, 160, 140, 50)            
        end
        love.graphics.setColor(255,255,255,255)
        love.graphics.print("Level 1\nHighscore:\n"..highscore1, 345, 110)
        love.graphics.print("Level 2\nHighscore:\n"..highscore2, 345, 160)

    end
end

function Menu:keypressed(key)
    if mode == 1 and state == 1 and key == "return" then
        level = selected
        levels:initialize()
        gamestate = "playing" 
    end

    if state == 0 then
        if key == "up" then
            if selected > 1 then
                selected = selected - 1
            end
        elseif key == "down" then
            if selected < 3 then
                selected = selected + 1
            end
        end

        if key == "return" and selected == 1 then
            state = 1
            selected = 1
        end
        if key == "return" and selected == 2 then
            love.graphics.toggleFullscreen()
        end
        if key == "return" and selected == 3 then
            love.event.quit()
        end
    end

    if state == 1 then
        if key == "up" and mode == 2 then
            if selected > 1 then
                selected = selected - 1
            end
        elseif key == "down" and mode == 2 then
            if selected < 4 then
                selected = selected + 1
            end
        end

        if key == "up" and mode == 1 then
            if selected > 1 then
                selected = selected - 1
            end
        elseif key == "down" and mode == 1 then
            if selected < 2 then
                selected = selected + 1
            end
        end

        if key == "right" then
            mode = 2
            selected = 1
        elseif key == "left" then
            mode = 1
            selected = 1
        end

        if mode == 2 then
            if selected == 1 and key == "return" and stars >= planecost and plane < 3 then
                stars = stars - planecost
                plane = plane + 1
                engine = 1
                fuel_tank = 1
                shield = 1
                local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 = 0\nhighscore2 = 0\nhighscore3 = 0\nhighscore4 = 0\nplane = "..plane.."\nengine = "..engine.."\nfuel_tank = "..fuel_tank.."\nshield = "..shield.."\nstars = "..stars.."\nend\n\nreturn Save\n"
	            storage.save("save.lua", save)
            elseif selected == 2 and key == "return" and stars >= enginecost and engine < 3 then
                stars = stars - enginecost
                engine = engine + 1
                local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 = 0\nhighscore2 = 0\nhighscore3 = 0\nhighscore4 = 0\nplane = "..plane.."\nengine = "..engine.."\nfuel_tank = "..fuel_tank.."\nshield = "..shield.."\nstars = "..stars.."\nend\n\nreturn Save\n"
            	storage.save("save.lua", save)
            elseif selected == 3 and key == "return" and stars >= ftankcost and fuel_tank < 4 and plane > 1 then
                stars = stars - ftankcost
                fuel_tank = fuel_tank + 1
                local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 = 0\nhighscore2 = 0\nhighscore3 = 0\nhighscore4 = 0\nplane = "..plane.."\nengine = "..engine.."\nfuel_tank = "..fuel_tank.."\nshield = "..shield.."\nstars = "..stars.."\nend\n\nreturn Save\n"
            	storage.save("save.lua", save)
            elseif selected == 4 and key == "return" and stars >= shieldcost and shield < 3 and plane > 2 then
                stars = stars - shieldcost
                shield = shield + 1
                local save = "-- "..game.." "..version.." save file\nBase = {}\nlocal Save = Base;\n\nfunction Save:load()\nhighscore1 = 0\nhighscore2 = 0\nhighscore3 = 0\nhighscore4 = 0\nplane = "..plane.."\nengine = "..engine.."\nfuel_tank = "..fuel_tank.."\nshield = "..shield.."\nstars = "..stars.."\nend\n\nreturn Save\n"
            	storage.save("save.lua", save)
            end
        end
    end

    if key == "escape" then
        state = 0
    end
end
